package com.ruoyi.common.core.domain.entity;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import javax.validation.constraints.*;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.ruoyi.common.annotation.DataSource;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.annotation.Excel.ColumnType;
import com.ruoyi.common.annotation.Excel.Type;
import com.ruoyi.common.annotation.Excels;
import com.ruoyi.common.core.domain.BaseEntity;
import com.ruoyi.common.xss.Xss;
import lombok.*;

/**
 * 用户对象 sys_user
 * 
 * @author ruoyi
 */
@Data
@Getter
@Setter
@ToString
@AllArgsConstructor
public class SysUser extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 用户ID */
    private Long userId;

    /** 用户名称 */
    @Excel(name = "人员姓名")
    private String userName;

    /** 登录名称 */
    @Excel(name = "登录账号")
    private String loginName;

    /** 部门ID */
    @Excel(name = "部门编号", type = Type.IMPORT)
    private Long deptId;

    /** 部门父ID */
    @TableField(exist=false)
    private Long parentId;

    /** 角色ID */
    @TableField(exist=false)
    private Long roleId;

    /** 用户类型 */
    private String userType;

    /** 用户邮箱 */
    @Excel(name = "用户邮箱")
    private String email;

    /** 手机号码 */
    @Excel(name = "手机号码")
    private String phonenumber;

    /** 用户性别 */
    @Excel(name = "用户性别", readConverterExp = "0=男,1=女,2=未知")
    private String sex;

    /** 用户头像 */
    private String avatar;

    /** 密码 */
    private String password;

    /** 盐加密 */
    private String salt;

    /** 帐号状态（0正常 1停用） */
    private String status;

    /** 删除标志（0代表存在 2代表删除） */
    private String delFlag;

    /** 最后登录IP */
    private String loginIp;

    /** 最后登录时间 */
    private Date loginDate;

    /** 密码最后更新时间 */
    private Date pwdUpdateDate;

    /** 用户地区 */
    @Excel(name = "用户地区")
    private String userarea;

    /** 民族 */
    @Excel(name = "民族",readConverterExp = "4=汉族,5=苗族,6=维吾尔族")
    private String nation;

    /** 出生年月 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "出生年月", width = 30, dateFormat = "yyyy-MM-dd")
    private Date birthday;

    public String getUserarea() {
        return userarea;
    }

    public void setUserarea(String userarea) {
        this.userarea = userarea;
    }

    public String getNation() {
        return nation;
    }

    public void setNation(String nation) {
        this.nation = nation;
    }

    public Date getBirthday() {
        return birthday;
    }

    public void setBirthday(Date birthday) {
        this.birthday = birthday;
    }

    public String getPolitics() {
        return politics;
    }

    public void setPolitics(String politics) {
        this.politics = politics;
    }

    public String getShemichengdu() {
        return shemichengdu;
    }

    public void setShemichengdu(String shemichengdu) {
        this.shemichengdu = shemichengdu;
    }

    public String getGraduate() {
        return graduate;
    }

    public void setGraduate(String graduate) {
        this.graduate = graduate;
    }

    public String getStartdata() {
        return startdate;
    }

    public void setStartdata(String startdata) {
        this.startdate = startdata;
    }

    public String getEnddata() {
        return enddate;
    }

    public void setEnddata(String enddata) {
        this.enddate = enddata;
    }

    public String getHelthy() {
        return helthy;
    }

    public void setHelthy(String helthy) {
        this.helthy = helthy;
    }

    /** 政治面貌 */
    @Excel(name = "政治面貌",readConverterExp = "1=党员,2=团员,3=群众")
    private String politics;

    /** 涉密程度 */
    @Excel(name = "涉密程度",readConverterExp = "0=一般涉密人员,1=重要涉密人员,2=核心涉密人员")
    private String shemichengdu;

    /** 学历 */
    @Excel(name = "学历")
    private String graduate;


    /** 健康状况 */
    private String helthy;

    /** 审核状态 */
    private String examine;

    /** 审核时间 */
    private String examinedate;

    /** 审核人 */
    private String examineuser;

    /** 是否持有护照和港澳通行证 */
    @Excel(name = "是否持有护照和港澳通行证",readConverterExp = "1=是,0=否")
    private String havePassport;

    /** 保密协议书 */
    private String confAgreement;

    /** 保密协议书文件名 */
    private String confName;

    public String getConfName() {
        return confName;
    }

    public void setConfName(String confName) {
        this.confName = confName;
    }

    /** 是否出入境备案 */
    @Excel(name = "是否具有出入境备案",readConverterExp = "1=是,0=否")
    private  String entryexitFiling;


    /** 生效时间 */
    @Excel(name = "生效时间", width = 30, dateFormat = "yyyy-MM-dd")
    private String startdate;

    /** 失效时间 */
    @Excel(name = "失效时间", width = 30, dateFormat = "yyyy-MM-dd")
    private String enddate;

    public String getHavePassport() {
        return havePassport;
    }

    public void setHavePassport(String havePassport) {
        this.havePassport = havePassport;
    }

    public String getConfAgreement() {
        return confAgreement;
    }

    public void setConfAgreement(String confAgreement) {
        this.confAgreement = confAgreement;
    }

    public String getEntryexitFiling() {
        return entryexitFiling;
    }

    public void setEntryexitFiling(String entryexitFiling) {
        this.entryexitFiling = entryexitFiling;
    }

    public String getExaminedate() {
        return examinedate;
    }

    public void setExaminedate(String examinedate) {
        this.examinedate = examinedate;
    }

    public String getExamineuser() {
        return examineuser;
    }

    public void setExamineuser(String examineuser) {
        this.examineuser = examineuser;
    }

    public SysUser(String examine) {
        this.examine = examine;
    }

    public String getExamine() {
        return examine;
    }

    public void setExamine(String examine) {
        this.examine = examine;
    }

    /** 部门对象 */
    @Excels({
        @Excel(name = "部门名称", targetAttr = "deptName", type = Type.EXPORT)
    })
    @TableField(exist=false)
    private SysDept dept;

    @TableField(exist=false)
    private List<SysRole> roles;

    /** 角色组 */
    @TableField(exist=false)
    private Long[] roleIds;

    /** 岗位组 */
    @TableField(exist=false)
    private Long[] postIds;


    @TableField(exist=false)
    private List<SysPostVO> posts;

    public SysUser()
    {

    }

    public SysUser(Long userId)
    {
        this.userId = userId;
    }

    public Long getUserId()
    {
        return userId;
    }

    public void setUserId(Long userId)
    {
        this.userId = userId;
    }

    public boolean isAdmin()
    {
        return isAdmin(this.userId);
    }

    public static boolean isAdmin(Long userId)
    {
        return userId != null && 1L == userId;
    }

    public Long getDeptId()
    {
        return deptId;
    }

    public void setDeptId(Long deptId)
    {
        this.deptId = deptId;
    }

    public Long getParentId()
    {
        return parentId;
    }

    public void setParentId(Long parentId)
    {
        this.parentId = parentId;
    }

    public Long getRoleId()
    {
        return roleId;
    }

    public void setRoleId(Long roleId)
    {
        this.roleId = roleId;
    }

    @Xss(message = "登录账号不能包含脚本字符")
    @NotBlank(message = "登录账号不能为空")
    @Size(min = 0, max = 30, message = "登录账号长度不能超过30个字符")
    public String getLoginName()
    {
        return loginName;
    }

    public void setLoginName(String loginName)
    {
        this.loginName = loginName;
    }

    @Xss(message = "用户昵称不能包含脚本字符")
    @Size(min = 0, max = 30, message = "用户昵称长度不能超过30个字符")
    public String getUserName()
    {
        return userName;
    }

    public void setUserName(String userName)
    {
        this.userName = userName;
    }

    public String getUserType()
    {
        return userType;
    }

    public void setUserType(String userType)
    {
        this.userType = userType;
    }

    @Email(message = "邮箱格式不正确")
    @Size(min = 0, max = 50, message = "邮箱长度不能超过50个字符")
    public String getEmail()
    {
        return email;
    }

    public void setEmail(String email)
    {
        this.email = email;
    }

    @Size(min = 0, max = 11, message = "手机号码长度不能超过11个字符")
    public String getPhonenumber()
    {
        return phonenumber;
    }

    public void setPhonenumber(String phonenumber)
    {
        this.phonenumber = phonenumber;
    }

    public String getSex()
    {
        return sex;
    }

    public void setSex(String sex)
    {
        this.sex = sex;
    }

    public String getAvatar()
    {
        return avatar;
    }

    public void setAvatar(String avatar)
    {
        this.avatar = avatar;
    }

    @JsonIgnore
    public String getPassword()
    {
        return password;
    }

    public void setPassword(String password)
    {
        this.password = password;
    }

    @JsonIgnore
    public String getSalt()
    {
        return salt;
    }

    public void setSalt(String salt)
    {
        this.salt = salt;
    }

    public String getStatus()
    {
        return status;
    }

    public void setStatus(String status)
    {
        this.status = status;
    }

    public String getDelFlag()
    {
        return delFlag;
    }

    public void setDelFlag(String delFlag)
    {
        this.delFlag = delFlag;
    }

    public String getLoginIp()
    {
        return loginIp;
    }

    public void setLoginIp(String loginIp)
    {
        this.loginIp = loginIp;
    }

    public Date getLoginDate()
    {
        return loginDate;
    }

    public void setLoginDate(Date loginDate)
    {
        this.loginDate = loginDate;
    }

    public Date getPwdUpdateDate()
    {
        return pwdUpdateDate;
    }

    public void setPwdUpdateDate(Date pwdUpdateDate)
    {
        this.pwdUpdateDate = pwdUpdateDate;
    }

    public SysDept getDept()
    {
        if (dept == null)
        {
            dept = new SysDept();
        }
        return dept;
    }

    public void setDept(SysDept dept)
    {
        this.dept = dept;
    }

    public List<SysRole> getRoles()
    {
        return roles;
    }

    public void setRoles(List<SysRole> roles)
    {
        this.roles = roles;
    }

    public Long[] getRoleIds()
    {
        return roleIds;
    }

    public void setRoleIds(Long[] roleIds)
    {
        this.roleIds = roleIds;
    }

    public Long[] getPostIds()
    {
        return postIds;
    }

    public void setPostIds(Long[] postIds)
    {
        this.postIds = postIds;
    }

    public String getStartdate() {
        return startdate;
    }

    public void setStartdate(String startdate) {
        this.startdate = startdate;
    }

    public String getEnddate() {
        return enddate;
    }

    public void setEnddate(String enddate) {
        this.enddate = enddate;
    }

    public List<SysPostVO> getPosts() {
        return posts;
    }

    public void setPosts(List<SysPostVO> posts) {
        this.posts = posts;
    }

    @Override
    public String toString() {
        return "SysUser{" +
                "userId=" + userId +
                ", deptId=" + deptId +
                ", parentId=" + parentId +
                ", roleId=" + roleId +
                ", loginName='" + loginName + '\'' +
                ", userName='" + userName + '\'' +
                ", userType='" + userType + '\'' +
                ", email='" + email + '\'' +
                ", phonenumber='" + phonenumber + '\'' +
                ", sex='" + sex + '\'' +
                ", avatar='" + avatar + '\'' +
                ", password='" + password + '\'' +
                ", salt='" + salt + '\'' +
                ", status='" + status + '\'' +
                ", delFlag='" + delFlag + '\'' +
                ", loginIp='" + loginIp + '\'' +
                ", loginDate=" + loginDate +
                ", pwdUpdateDate=" + pwdUpdateDate +
                ", userarea='" + userarea + '\'' +
                ", nation='" + nation + '\'' +
                ", birthday=" + birthday +
                ", politics='" + politics + '\'' +
                ", shemichengdu='" + shemichengdu + '\'' +
                ", graduate='" + graduate + '\'' +
                ", startdate='" + startdate + '\'' +
                ", enddate='" + enddate + '\'' +
                ", helthy='" + helthy + '\'' +
                ", examine='" + examine + '\'' +
                ", examinedate='" + examinedate + '\'' +
                ", examineuser='" + examineuser + '\'' +
                ", havePassport='" + havePassport + '\'' +
                ", confAgreement='" + confAgreement + '\'' +
                ", entryexitFiling='" + entryexitFiling + '\'' +
                ", confName='" + confName + '\'' +
                ", dept=" + dept +
                ", roles=" + roles +
                ", roleIds=" + Arrays.toString(roleIds) +
                ", postIds=" + Arrays.toString(postIds) +
                '}';
    }
}
